"use strict";
var platform_1 = require("platform");
var Buffer = require('buffer/').Buffer;
var bcrypt = require('bcryptjs');
if (platform_1.isIOS) {
    // security
    var randomBytes = function (length, cb) {
        var bytes = NSMutableData.dataWithLength(length);
        SecRandomCopyBytes(null, length, bytes.mutableBytes);
        var buf = new Buffer(bytes.base64EncodedStringWithOptions(0), 'base64');
        if (cb) {
            cb(null, buf);
        }
        else {
            return buf;
        }
    };
    bcrypt.setRandomFallback(randomBytes);
}
else if (platform_1.isAndroid) {
    var randomBytes = function (length, cb) {
        var output = Array.create("byte", length);
        new java.security.SecureRandom().nextBytes(output);
        var buf = new Buffer(android.util.Base64.encodeToString(output, android.util.Base64.DEFAULT), 'base64');
        if (cb) {
            cb(null, buf);
        }
        else {
            return buf;
        }
    };
    bcrypt.setRandomFallback(randomBytes);
}
else {
    throw "unknown platform execution";
}
